unit MorphPrgDllUnit;

interface

uses
  Windows;

type MP_STATUS = Integer;

type PBoolean = ^Boolean;

const MAX_NUM_DEVICES = 50;

const MAX_NUM_DEVICE_NAME_CHARS =  50;
const MAX_NUM_SERIAL_NUMBER_CHARS = 50;

type TDeviceName = array [0..(MAX_NUM_DEVICE_NAME_CHARS - 1)] of Char;
type PDeviceName = ^TDeviceName;

type TSerialNumber = array [0..(MAX_NUM_SERIAL_NUMBER_CHARS - 1)] of Char;
type PSerialNumber = ^TSerialNumber;

const MAX_NUM_DLL_VERSION_CHARS = 10;

type TDllVersion = array [0..(MAX_NUM_DLL_VERSION_CHARS - 1)] of Char;
type PDllVersion = ^TDllVersion;

const MAX_NUM_ERROR_MESSAGE_CHARS = 100;

type TErrorMessage = array [0..(MAX_NUM_ERROR_MESSAGE_CHARS - 1)] of Char;
type PErrorMessage = ^TErrorMessage;

type TMorphPrg = class
 public
  constructor create;
  function MP_GetNumMorphICDevices(DeviceNamesReturned: PDword): MP_STATUS;
  function MP_GetMorphICDeviceName(DeviceIndex: Dword; DeviceNameBuffer: PDeviceName; BufferSize: Dword): MP_STATUS;
  function MP_GetNumMorphICDeviceSerialNumbers(DeviceName: String; SerialNumbersReturned: PDword): MP_STATUS;
  function MP_GetMorphICDeviceSerialNumber(DeviceName: String; SerialNumberIndex: Dword; SerialNumberBuffer: PSerialNumber; BufferSize: Dword): MP_STATUS;
  function MP_OpenSpecifiedMorphICDevice(DeviceName: String; SerialNumber: String; pMpHandle: PDword): MP_STATUS;
  function MP_OpenMorphICDevice(pMpHandle: PDword): MP_STATUS;
  function MP_CloseMorphICDevice(mphandle: Dword): MP_STATUS;
  function MP_InitMorphICDevice(mphandle: Dword): MP_STATUS;
  function MP_ProgramMorphICDevice(mphandle: Dword; FileName: String): MP_STATUS;
  function MP_IsMorphICDeviceProgrammed(mphandle: Dword; pbProgramState: PBoolean): MP_STATUS;
  function MP_GetMorphICDllVersion(DllVersionBuffer: pDllVersion; BufferSize: Dword): MP_STATUS;
  function MP_GetMorphICErrorCodeString(Language: String; StatusCode: MP_STATUS; ErrorMessageBuffer: PErrorMessage; BufferSize: Dword): MP_STATUS;
end;


const
  MORPHPRG_DLL_Name = 'morphprg.dll';

  MP_SUCCESS = 0;

  ENGLISH = 'EN';

  
implementation

function GetNumMorphICDevices(DeviceNamesReturned: PDword): MP_STATUS; stdcall ; External MORPHPRG_DLL_Name name 'GetNumMorphICDevices';
function GetMorphICDeviceName(DeviceIndex: Dword; DeviceNameBuffer: PDeviceName; BufferSize: Dword): MP_STATUS; stdcall ; External MORPHPRG_DLL_Name name 'GetMorphICDeviceName';
function GetNumMorphICDeviceSerialNumbers(DeviceName: String; SerialNumbersReturned: PDword): MP_STATUS; stdcall ; External MORPHPRG_DLL_Name name 'GetNumMorphICDeviceSerialNumbers';
function GetMorphICDeviceSerialNumber(DeviceName: String; SerialNumberIndex: Dword; SerialNumberBuffer: PSerialNumber; BufferSize: Dword): MP_STATUS; stdcall ; External MORPHPRG_DLL_Name name 'GetMorphICDeviceSerialNumber';
function OpenSpecifiedMorphICDevice(DeviceName: String; SerialNumber: String; pMpHandle: PDword): MP_STATUS; stdcall ; External MORPHPRG_DLL_Name name 'OpenSpecifiedMorphICDevice';
function OpenMorphICDevice(pMpHandle: PDword): MP_STATUS; stdcall ; External MORPHPRG_DLL_Name name 'OpenMorphICDevice';
function CloseMorphICDevice(mphandle: Dword): MP_STATUS; stdcall ; External MORPHPRG_DLL_Name name 'CloseMorphICDevice';
function InitMorphICDevice(mphandle: Dword): MP_STATUS; stdcall ; External MORPHPRG_DLL_Name name 'InitMorphICDevice';
function ProgramMorphICDevice(mphandle: Dword; FileName: String): MP_STATUS; stdcall ; External MORPHPRG_DLL_Name name 'ProgramMorphICDevice';
function IsMorphICDeviceProgrammed(mphandle: Dword; pbProgramState: PBoolean): MP_STATUS; stdcall ; External MORPHPRG_DLL_Name name 'IsMorphICDeviceProgrammed';
function GetMorphICDllVersion(DllVersionBuffer: pDllVersion; BufferSize: Dword): MP_STATUS; stdcall ; External MORPHPRG_DLL_Name name 'GetMorphICDllVersion';
function GetMorphICErrorCodeString(Language: PChar; StatusCode: MP_STATUS; ErrorMessageBuffer: PErrorMessage; BufferSize: Dword): MP_STATUS; stdcall ; External MORPHPRG_DLL_Name name 'GetMorphICErrorCodeString';


constructor TMorphPrg.create;
begin
end;

function  TMorphPrg.MP_GetNumMorphICDevices(DeviceNamesReturned: PDword): MP_STATUS;
begin
  Result := GetNumMorphICDevices(DeviceNamesReturned);
end;

function  TMorphPrg.MP_GetMorphICDeviceName(DeviceIndex: Dword; DeviceNameBuffer: PDeviceName; BufferSize: Dword): MP_STATUS;
begin
  Result := GetMorphICDeviceName(DeviceIndex, DeviceNameBuffer, BufferSize);
end;

function  TmorphPrg.MP_GetNumMorphICDeviceSerialNumbers(DeviceName: String; SerialNumbersReturned: PDword): MP_STATUS;
begin
  Result := GetNumMorphICDeviceSerialNumbers(DeviceName, SerialNumbersReturned);
end;

function  TmorphPrg.MP_GetMorphICDeviceSerialNumber(DeviceName: String; SerialNumberIndex: Dword;
                                                    SerialNumberBuffer: PSerialNumber; BufferSize: Dword): MP_STATUS;
begin
  Result := GetMorphICDeviceSerialNumber(DeviceName, SerialNumberIndex, SerialNumberBuffer, BufferSize);
end;

function  TMorphPrg.MP_OpenSpecifiedMorphICDevice(DeviceName: String; SerialNumber: String; pMpHandle: PDword): MP_STATUS;
begin
  Result := OpenSpecifiedMorphICDevice(DeviceName, SerialNumber, pMpHandle);
end;

function  TMorphPrg.MP_OpenMorphICDevice(pMpHandle: PDword): MP_STATUS;
begin
  Result := OpenMorphICDevice(pMpHandle);
end;

function  TMorphPrg.MP_CloseMorphICDevice(mphandle: Dword): MP_STATUS;
begin
  Result := CloseMorphICDevice(mphandle);
end;

function  TMorphPrg.MP_InitMorphICDevice(mphandle: Dword): MP_STATUS;
begin
  Result := InitMorphICDevice(mphandle);
end;

function  TMorphPrg.MP_ProgramMorphICDevice(mphandle: Dword; FileName: String): MP_STATUS;
begin
  Result := ProgramMorphICDevice(mphandle, FileName);
end;

function  TMorphPrg.MP_IsMorphICDeviceProgrammed(mphandle: Dword; pbProgramState: PBoolean): MP_STATUS;
begin
  Result := IsMorphICDeviceProgrammed(mphandle, pbProgramState);
end;

function  TMorphPrg.MP_GetMorphICDllVersion(DllVersionBuffer: pDllVersion; BufferSize: Dword): MP_STATUS;
begin
  Result := GetMorphICDllVersion(DllVersionBuffer, BufferSize);
end;

function  TMorphPrg.MP_GetMorphICErrorCodeString(Language: String; StatusCode: MP_STATUS; ErrorMessageBuffer: PErrorMessage; BufferSize: Dword): MP_STATUS;
begin
  Result := GetMorphICErrorCodeString(PChar(Language), StatusCode, ErrorMessageBuffer, BufferSize);
end;

end.
